PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Classes | Protected Member Functions | List of all members
PSortedList< T > Class Template Reference

This template class maps the PAbstractSortedList to a specific object type. More...

`#include <lists.h>`

Inheritance diagram for PSortedList< T >:
[legend]
Collaboration diagram for PSortedList< T >:
[legend]

## Classes
class | const_iterator
class | iterator

## Public Member Functions
Construction
| PSortedList ()
| Create a new, empty, sorted list. More...
Overrides from class PObject
virtual PObject * | Clone () const
| Make a complete duplicate of the list. More...
New functions for class
T & | operator[] (PINDEX index) const
| Retrieve a reference to the object in the list. More...
Public Member Functions inherited from PAbstractSortedList
| PAbstractSortedList ()
| Create a new, empty, sorted list. More...
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two lists. More...
virtual PBoolean | SetSize (PINDEX newSize)
| This function is meaningless for lists. More...
virtual PINDEX | Append (PObject *obj)
| Add a new object to the collection. More...
virtual PINDEX | Insert (const PObject &before, PObject *obj)
| Add a new object to the collection. More...
virtual PINDEX | InsertAt (PINDEX index, PObject *obj)
| Add a new object to the collection. More...
virtual PBoolean | Remove (const PObject *obj)
| Remove the object from the collection. More...
virtual PObject * | RemoveAt (PINDEX index)
| Remove the object at the specified ordinal index from the collection. More...
virtual void | RemoveAll ()
| Remove all of the elements in the collection. More...
virtual PBoolean | SetAt (PINDEX index, PObject *val)
| This method simply returns false as the list order is mantained by the class. More...
virtual PObject * | GetAt (PINDEX index) const
| Get the object at the specified ordinal position. More...
virtual PINDEX | GetObjectsIndex (const PObject *obj) const
| Search the collection for the specific instance of the object. More...
virtual PINDEX | GetValuesIndex (const PObject &obj) const
| Search the collection for the specified value of the object. More...
Public Member Functions inherited from PCollection
| PCollection (PINDEX initialSize=0)
| Create a new collection. More...
virtual void | PrintOn (ostream &strm) const
| Print the collection on the stream. More...
PINLINE void | AllowDeleteObjects (PBoolean yes=true)
| Allow or disallow the deletion of the objects contained in the collection. More...
void | DisallowDeleteObjects ()
| Disallow the deletion of the objects contained in the collection. More...
Public Member Functions inherited from PContainer
| PContainer (PINDEX initialSize=0)
| Create a new unique container. More...
| PContainer (const PContainer &cont)
| Create a new refernce to container. More...
PContainer & | operator= (const PContainer &cont)
| Assign one container reference to another. More...
virtual | ~PContainer ()
| Destroy the container class. More...
virtual PINDEX | GetSize () const
| Get the current size of the container. More...
PBoolean | SetMinSize (PINDEX minSize)
| Set the minimum size of container. More...
virtual PBoolean | IsEmpty () const
| Determine if the container is empty. More...
PBoolean | IsUnique () const
| Determine if container is unique reference. More...
virtual PBoolean | MakeUnique ()
| Make this instance to be the one and only reference to the container contents. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions
| PSortedList (int dummy, const PSortedList *c)
Protected Member Functions inherited from PAbstractSortedList
void | RemoveElement (PSortedListElement *node)
void | LeftRotate (PSortedListElement *node)
void | RightRotate (PSortedListElement *node)
void | DeleteSubTrees (PSortedListElement *node, bool deleteObject)
PSortedListElement * | FindElement (const PObject &obj, PINDEX *index) const
PSortedListElement * | FindElement (const PObject *obj, PINDEX *index) const
Protected Member Functions inherited from PCollection
PINLINE | PCollection (int dummy, const PCollection *coll)
| Constructor used in support of the Clone() function. More...
Protected Member Functions inherited from PContainer
| PContainer (int dummy, const PContainer *cont)
| Constructor used in support of the Clone() function. More...
| PContainer (PContainerReference &reference)
| Construct using static PContainerReference. More...
virtual void | DestroyContents ()=0
| Destroy the container contents. More...
virtual void | AssignContents (const PContainer &c)
| Copy the container contents. More...
void | CopyContents (const PContainer &c)
| Copy the container contents. More...
void | CloneContents (const PContainer *src)
| Create a duplicate of the container contents. More...
void | Destruct ()
| Internal function called from container destructors. More...
virtual void | DestroyReference ()
| Destroy the PContainerReference instance. More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Iterators
typedef T | value_type
iterator | begin ()
iterator | end ()
iterator | rbegin ()
iterator | rend ()
const_iterator | begin () const
const_iterator | end () const
const_iterator | rbegin () const
const_iterator | rend () const
value_type & | front ()
value_type & | back ()
const value_type & | front () const
const value_type & | back () const
iterator | find (const value_type &obj)
const_iterator | find (const value_type &obj) const
void | erase (const iterator &it)
void | erase (const const_iterator &it)

## Additional Inherited Members
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Protected Attributes inherited from PAbstractSortedList
PSortedListInfo * | m_info
Friends inherited from PObject

## Detailed Description

### template<class T>
class PSortedList< T >

This template class maps the PAbstractSortedList to a specific object type.

The functions in this class primarily do all the appropriate casting of types.

Note that if templates are not used the `PDECLARE_SORTED_LIST` macro will simulate the template instantiation.

## Member Typedef Documentation

template<class T>

typedef T PSortedList< T >::value_type

## Constructor & Destructor Documentation

template<class T>

PSortedList< T >::PSortedList | ( |  | ) |
| inline

Create a new, empty, sorted list.

Note that by default, objects placed into the list will be deleted when removed or when all references to the list are destroyed.

Referenced by PSortedList< T >::Clone().

template<class T>

PSortedList< T >::PSortedList | ( | int | dummy,
|  | const PSortedList< T > * | c
| ) |  |
| inline protected

## Member Function Documentation

template<class T>

value_type& PSortedList< T >::back | ( |  | ) |
| inline

References PSortedList< T >::rbegin().

template<class T>

const value_type& PSortedList< T >::back | ( |  | ) | const
| inline

References PSortedList< T >::rbegin().

template<class T>

iterator PSortedList< T >::begin | ( |  | ) |
| inline

References PContainer::IsEmpty(), PAbstractSortedList::m_info, and PSortedListInfo::OrderSelect().

Referenced by PSortedList< T >::front().

template<class T>

const_iterator PSortedList< T >::begin | ( |  | ) | const
| inline

References PContainer::IsEmpty(), PAbstractSortedList::m_info, and PSortedListInfo::OrderSelect().

template<class T>

virtual PObject* PSortedList< T >::Clone | ( |  | ) | const
| inline virtual

Make a complete duplicate of the list.

Note that all objects in the array are also cloned, so this will make a complete copy of the list.

Reimplemented from PObject.

References PNEW, and PSortedList< T >::PSortedList().

template<class T>

iterator PSortedList< T >::end | ( |  | ) |
| inline

template<class T>

const_iterator PSortedList< T >::end | ( |  | ) | const
| inline

template<class T>

void PSortedList< T >::erase | ( | const iterator & | it | ) |
| inline

References PAssert, PLogicError, and PAbstractSortedList::RemoveElement().

template<class T>

void PSortedList< T >::erase | ( | const const_iterator & | it | ) |
| inline

References PAssert, PLogicError, and PAbstractSortedList::RemoveElement().

template<class T>

iterator PSortedList< T >::find | ( | const value_type & | obj | ) |
| inline

References PAbstractSortedList::FindElement().

template<class T>

const_iterator PSortedList< T >::find | ( | const value_type & | obj | ) | const
| inline

References PAbstractSortedList::FindElement().

template<class T>

value_type& PSortedList< T >::front | ( |  | ) |
| inline

References PSortedList< T >::begin().

template<class T>

const value_type& PSortedList< T >::front | ( |  | ) | const
| inline

References PSortedList< T >::begin().

template<class T>

T& PSortedList< T >::operator[] | ( | PINDEX | index | ) | const
| inline

Retrieve a reference to the object in the list.

If there was not an object at that ordinal position or the index was beyond the size of the array then the function asserts.

The object accessed in this way is remembered by the class and further access will be fast.

Returns
  reference to the object at `index` position.

Parameters

  index | Index for entry

References PAbstractSortedList::GetAt().

template<class T>

iterator PSortedList< T >::rbegin | ( |  | ) |
| inline

References PContainer::IsEmpty(), PAbstractSortedList::m_info, and PSortedListInfo::OrderSelect().

Referenced by PSortedList< T >::back().

template<class T>

const_iterator PSortedList< T >::rbegin | ( |  | ) | const
| inline

References PContainer::IsEmpty(), PAbstractSortedList::m_info, and PSortedListInfo::OrderSelect().

template<class T>

iterator PSortedList< T >::rend | ( |  | ) |
| inline

template<class T>

const_iterator PSortedList< T >::rend | ( |  | ) | const
| inline

The documentation for this class was generated from the following file:

- lists.h